



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>《C与指针》第十一章练习</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">《C与指针》第十一章练习</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-21 01:22:13 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><strong>本章问题</strong></p>
<p>1.在你的系统中，你能够声明的静态数组最大的长度能达到多少？使用动态内存分配，你最大能获取的内存块有多少？</p>
<p>answer：</p>
<p>This will vary from system to system,there are several things that may affect the result on PC-based systems,including the memory model in use,the amount of space in the data and/or stack segment,the amount of available memory on the system,and so forth,the result on Unix systems will depend on the amount of available swap space,among other things.</p>
<p>(不同系统之间不同，在PC系统中有许多事情可以影响分配结果，包括存储器类型的使用，数据或堆栈段的空间大小，变量空间大小或者其他，Unix系统分配的结果依赖于swap空间或者其他原因)</p>
<p>2.当你一次请求分配500个字节的内存时，你实际获得的动态分配内存数量总共有多大？请你一次请求分配5000个字节又如何？它们存在区别吗？如果有，你如何解释？</p>
<p>answer：There are two explanations possible,Requesting smaller chunks may allow more memory to be allocated because the amount of memeory left over after the last allocation will be smaller,this would make the total for the smaller requests larger,More likely,though,is that the total for the smaller requests is smaller:this is due to the overhead of the extra space that malloc attaches to the memory in order to keep track of the size of each allocated chunk.</p>
<p>(可能有两种解释，要求更小的块可能会允许分配更多的内存，因为在最后内存分配剩余的总量会更小，这将会使较小的要求总量更大，也有可能要求更小的分配更小，这是因为额外的空间开销，是malloc附加用来跟踪每块已分配内存的大小的内存)</p>
<div>
<pre class="prettyprint linenums">//linux下可以调用malloc_usable_size函数来获取实际分配的内存<br />
#include &lt;stdio.h&gt;<br />
#include &lt;stdlib.h&gt;

int main()<br />
{<br />
    char *p;<br />
    p = malloc( * sizeof(char));<br />
    printf("%u",malloc_usable_size(p));<br />
    free(p);<br />
    p = malloc( * sizeof(char));<br />
    printf("\n%u",malloc_usable_size(p));<br />
    free(p);<br />
    return ;<br />
}</pre>
</div>
<p>运行结果：</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/934932/201611/934932-20161127103909815-1068672167.png" /></p>
<p>关于malloc_usable_size函数的具体用法参考：http://man7.org/linux/man-pages/man3/malloc_usable_size.3.html</p>
<p>3.在一个从文件读取字符串的程序中，有没有什么值可以合乎逻辑地作为输入缓冲区的长度？</p>
<p>answer：</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/934932/201611/934932-20161127111601268-1194936161.png" /></p>
<p>如果输入包含在一个文件中，它肯定是由其他程序（例如编辑器）放在那儿的。如果是这种情况，最长行的长度是由编辑器程序支持的，它会作出一个合乎逻辑的选择，确定你的输入缓冲区的大小。</p>
<p>4.有些C编译器提供了一个称为alloca的函数，它与malloc函数的不同之处在于它在堆栈上分配内存，这种类型分配有什么优缺点？</p>
<p>answer：The primary advantage is that the memory will be automatically freed when the function that allocated it returns,this property occurs because of how stacks work,and it guarantees that there will be no memeory leaks,but this behavior is also a disadvantage,because the allocated memory disappears when the function returns,it cannot be used for data that are passed back to the calling program.</p>
<p>(最简单的优点就是当被分配内存的函数返回时，内存可以自动释放，由于堆栈的工作属性，它保障了不会发生内存泄露，但是这也是一个缺点，因为当函数返回时，分配的内存消失了，它不能被数据使用或被调用函数返回)</p>
<p>5.下面的程序用于读取整数，整数的范围在1和从标准输入读取的size之间，它返回每个值出现的次数，这个程序包含了几个错误，你能找出它们吗？</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/934932/201611/934932-20161127131026346-1305085420.png" /></p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/934932/201611/934932-20161127131105768-176225904.png" /></p>
<p>answer：</p>
<p>a 用字面值常量2作为整形值的长度。这个值在整形值长度为2个字节的机器上能正常工作。但在4字节整数的机器上，实际分配的内存将只是所需内存的一半，应该换用sizeof</p>
<p>b 从malloc函数返回的值未被检查，如果内存不足，它将是NULL</p>
<p>c 把指针退到数组左边界的左边来调整下标的范围或许行得通，但它违背了标准关于指针不能越过数组左边界的规定</p>
<p>d 指针经过调整以后，第一个元素的下标变成了1，接着for循环将错误的从0开始，在许多系统中，这个错误将破坏malloc所使用的用于追踪堆的信息，常常导致程序奔溃</p>
<p>e 数组增值前并未检查输入值是否位于合适的范围内，非法的输入值可能会以一种有趣的方式导致程序奔溃</p>
<p>f 如果数组应该返回，它不能被free函数释放</p>
<div>
<pre class="prettyprint linenums">//修改后的函数<br />
#include &lt;stdio.h&gt;

int *frequency(int size)<br />
{<br />
    int *array;<br />
    int i;<br />
    array = (int *)malloc(size * sizeof(int));

    if(array == NULL)<br />
        return NULL;

    for(i = ; i &lt; size; i++)<br />
        array[i] = ;

    whlie(scanf("%d",&amp;i) == ){<br />
        if(i &lt;=  &amp;&amp; i &gt; size)<br />
            return NULL;<br />
        array[i - ] += ;<br />
    }<br />
    return array;<br />
}</pre>
</div>
<p>6.假定你需要编写一个程序，并希望最大限度的减少堆栈的使用量，动态内存分配能不能对你有所帮助？使用标量数据又如何？</p>
<p>answer：Yes,dynamic allocation will use less stack space because the memory for the arrays will be taken from the heap rather than the stack,Dynamic allocation of scalars will help only if the values being allocated are larger than the size of a pointer,as it would be with a large structure,there is no gain in dynamically allocating an integer because the pointer variable you must have to keep track of it takes just as much space as the integer itself.</p>
<p>(是的，动态分配将会使用更少的堆栈空间因为数组的内存将会从内存堆中获取而不是堆栈，标量的动态分配仅仅在分配的大小远远大于一个指针时才能有所帮助，对一个整形变量使用动态内存分配没有什么好处，因为将会有一个指针变量用来跟踪这个整形变量它自己)</p>
<p>7.在程序11.4b中，删除两个free函数的调用会导致什么结果？</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/934932/201611/934932-20161127132557409-763185058.png" /></p>
<p>answer：Memory leaks would be possible,but only when either the second or third allocations failed,meanning that the program had nearly run out of memory anyway,</p>
<p>(内存可能会泄露，在第二次或第三次分配失败时，意味着程序的内存被耗尽)</p>
<p><strong>本章练习</strong></p>
<p>1.请你尝试编写calloc函数，函数内部使用malloc函数来获取内存。</p>
<p>answer：</p>
<div>
<pre class="prettyprint linenums">void *mycalloc(size_t num_element, size_t element_size){<br />
    int i;<br />
    n_element = num_element * element_size;<br />
    char *p = malloc(n_element);<br />
    if(p == NULL)<br />
        return NULL;<br />
    for(i = ; i &lt; n_element; i++)<br />
        p[i] = ;<br />
    return p;<br />
}</pre>
</div>
<p>2.编写一个函数，从标准输入读取一列整数，把这些值存储于一个动态分配的数组中并返回这个数组，函数通过观察EOF判断输入是否结束，数组的第一个数是数组包含的值的个数，它的后面就是这些整数值。</p>
<p>answer：</p>
<div>
<pre class="prettyprint linenums">#include &lt;stdio.h&gt;<br />
#include &lt;stdlib.h&gt;

#define DELTA 100

int *read()<br />
{<br />
    int *array;<br />
    int count;<br />
    int size;<br />
    int value;

    size = DELTA;<br />
    count = ;<br />
    array = malloc((size + ) * sizeof(int));

    if(array == NULL)<br />
        return NULL;<br />
    while((scanf("%d",&amp;value)) == ){<br />
        count++;<br />
        if(count &gt;= size){<br />
            size += DELTA;<br />
            array = realloc(array,(size + ) * sizeof(int));<br />
            if(array == NULL)<br />
                return NULL;<br />
        }<br />
        array[count] = value;<br />
    }

    if(count &lt; size){<br />
        array = realloc(array,(count + ) * sizeof(int));<br />
        if(array == NULL)<br />
            return NULL;<br />
    }<br />
    array[] = count;<br />
    return array;<br />
}</pre>
</div>
<p>这个解决办法里有一个相当不错的技巧，就是预定义的那个DELTA，它相当于一个缓冲区，既不用每次多输入一个数据就要重新申请分一次内存，又保证不会浪费太多的内存，这个解决办法的意思就是说，每次申请DELTA个空间，不够了再添加DELTA个空间，最后发现没有用到的空间再还回去，一个平衡效率和内存浪费之间的解决办法。</p>
<p>3.编写一个函数，从标准输入读取一个字符串，把字符串复制到动态内存分配的内存中，并返回该字符串的拷贝，这个函数不应该对读入字符串的长度作任何限制！</p>
<p>answer：</p>
<div>
<pre class="prettyprint linenums">#include &lt;stdio.h&gt;<br />
#include &lt;stdlib.h&gt;<br />
#include &lt;assert.h&gt;

#define DELTA 256

char *readstring()<br />
{<br />
    static char *buffer = NULL;<br />
    static int buffer_size = ;<br />
    int ch;<br />
    int len = ;<br />
    char *bp = buffer;

    do{<br />
        ch = getchar();<br />
        if(ch == '\n' &amp;&amp; ch == EOF)<br />
            ch = '\0';

        if(len &gt; buffer_size){<br />
            buffer_size += DELTA;<br />
            buffer = realloc(buffer,buffer_size);<br />
            assert(buffer != NULL);<br />
            bp = buffer + len;<br />
        }<br />
        *bp++ = ch;<br />
        len++;<br />
    }while(ch != '\0');

    bp = malloc(len);<br />
    assert(bp != NULL);<br />
    strcpy(bp,buffer);<br />
    return bp;<br />
}</pre>
</div>
<p>4.编写一个程序，按照下图中的样子创建数据结构，最后三个对象都是动态分配的结构。第一个对象则可能是一个静态的指向结构的指针。你不必使这个程序过于全面--我们将在下一章讨论这个结构。</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/934932/201611/934932-20161127203042612-488247846.png" /></p>
<p>answer:</p>
<div>
<pre class="prettyprint linenums">#include &lt;stdio.h&gt;<br />
#include &lt;stdlib.h&gt;

typedef struct LIST{<br />
    int data;<br />
    struct LIST *link;<br />
}List;

List *newlist(int value)<br />
{<br />
    List *new;<br />
    new = (List *)malloc(sizeof(List));<br />
    new-&gt;data = value;<br />
    return new;<br />
}

int main()<br />
{<br />
    List *head;<br />
    head = newnode();<br />
    head-&gt;link = newnode();<br />
    head-&gt;link-&gt;link = newnode();<br />
    head-&gt;link-&gt;link-&gt;link = NULL;<br />
    return ;<br />
}</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/wq1z05z9.html">&lbrack;C&num;&rsqb;如何让webbrowser控件支持Html5</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qwjwzr8.html">js原声快速实现选项卡</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qnv2pk8.html">SQL Azure &lpar;16&rpar; 创建PaaS SQL Azure V12数据库</a>
		</li>
						<li><a href="https://www.batexi.com/a/390ronm9.html">discuz X3&period;1 关于分表 和 分表数据迁移</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq1ypn4q.html">Python GUI编程--Tkinter</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmm4609.html">线程高级应用-心得6-java5线程并发库中同步工具类（synchronizers），新知识大用途</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vm2xo8.html">单例模式简单解析--Singleton 单例模式（懒汉方式和饿汉方式）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1jzv19.html">GDAL读取tiff文件&sol;C&plus;&plus;源码</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdn4ll8.html">Object类型</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv11771q.html">HDU - 5036 Operation the Sequence</a>
		</li>
						<li><a href="https://www.batexi.com/a/950gex68.html">&lbrack;新概念英语II 笔记&rsqb; Lesson 3&colon; Please Send Me a Card</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpolwr9.html">APICloud界面间跳转</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpmx439.html">很好的一个dp题目 Codeforces Round &num;326 &lpar;Div&period; 2&rpar; D    dp</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4y1ok9.html">当map遇到parseInt</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyy5jx2q.html">【转载】springboot四 全局异常处理</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1v6n49.html">【CH5104】I-country 线性dp&plus;路径输出</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gy1rmq.html">Jquery   组 radio控与tr变色</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4j2n73q.html">任意两点间的最短路问题（Floyd-Warshall算法）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjz5269.html">Adobe Photoshop CS6简单的破解</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2mv4j9.html">unity3d-游戏实战突出重围，第二天 制作血条</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/e9jpo709.html">js动画之链式运动</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q7n5k19.html">MFC-01-Chapter01&colon;Hello&comma;MFC---1&period;3 第一个MFC程序（03）</a>
			</li>
						<li><a href="https://www.batexi.com/a/xq4noxn9.html">Anagrams</a>
			</li>
						<li><a href="https://www.batexi.com/a/4qn5ok3q.html">inside the C&plus;&plus; Object model总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/0qw07yl9.html">android&period;os&period;NetworkOnMainThreadException异常</a>
			</li>
						<li><a href="https://www.batexi.com/a/39r1d2m8.html">google软件测试之道--读后笔记</a>
			</li>
						<li><a href="https://www.batexi.com/a/r93vxmn8.html">克隆虚拟机重启服务时 Error&colon;No suitable device found&colon; no device found for connection &amp;quot&semi;System eth0&amp;quot&semi;</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q7gznkq.html">CTE</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q22jpwq.html">seajs封装js方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/4qnyvwg8.html">linux命令：xargs</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
